package dm_taquin.etud;

import java.applet.AudioClip;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageProducer;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Vue extends JFrame{
	private Controleur controleur;
	private Modele modele;
	private JButton[][] buttons;
	private Hashtable<Integer, ImageIcon> icons;

	public Vue(Modele modele)
	{
		super("Jeux de Taquin");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.modele=modele;
		this.controleur=new  Controleur(this,modele);
		this.buttons = new JButton[this.modele.getXMax()+1][this.modele.getYMax()+1];
		 

		JPanel panel = new JPanel(new GridLayout(this.modele.getYMax()+1, this.modele.getXMax()+1));
		icons  = new Hashtable<Integer, ImageIcon>();
		
		ImageIcon icon = new ImageIcon(this.getClass().getClassLoader().getResource("dm_taquin/ressources/image.jpg"));
		ImageProducer ip = icon.getImage().getSource();
		int v=0;
		for (int y =0; y <= this.modele.getYMax(); y++)
			for (int x=0; x <= this.modele.getXMax(); x++)
			{
				
				int w = icon.getIconWidth()/(modele.getXMax()+1);
				int h = icon.getIconHeight()/(modele.getYMax()+1); 
				CropImageFilter cif = new CropImageFilter(x*w,y*h, w , h);
				FilteredImageSource fis = new FilteredImageSource(ip, cif);
				Toolkit tk = Toolkit.getDefaultToolkit();
				Image img = tk.createImage(fis);
				icons.put(v, new  ImageIcon(img));
				v++;
				this.buttons[x][y]= new JButton();
				this.buttons[x][y].setPreferredSize(new Dimension(w,h));
				this.buttons[x][y].addActionListener(this.controleur);
				panel.add(this.buttons[x][y]);
			}
		
		this.paint();			
		this.add(panel);
		this.pack();
	}
	
	public void fin()
	{
		AudioClip audioClip;
		audioClip = JApplet.newAudioClip(this.getClass().getClassLoader().getResource("dm_taquin/ressources/music.wav"));
		audioClip.loop();
		
		//JOptionPane.showMessageDialog(this,"TREC'H");
		Icon icon = new ImageIcon(this.getClass().getClassLoader().getResource("dm_taquin/ressources/icon.png"));
		JOptionPane.showMessageDialog(this,
			    "Si, si",
			    "Que la paix soit avec toi",
			    JOptionPane.INFORMATION_MESSAGE,
			    icon);

		System.exit(0);

	}

	public JButton[][] getButtons() {
		return buttons;
	}

	public void paint()
	{
		for (int x =0; x <= this.modele.getXMax(); x++)
			for (int y=0; y <= this.modele.getYMax(); y++)
			{
				if (x!=modele.getXVide() || y!= modele.getYVide())
				{


					//this.buttons[x][y].setText(new Integer(this.modele.getTab()[x][y]).toString());
					this.buttons[x][y].setIcon(icons.get(this.modele.getTab()[x][y]));
				}
					
				else
				{
					//this.buttons[x][y].setText("");
					this.buttons[x][y].setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("dm_taquin/ressources/vide.jpg")));
					
				}
			
			}	
				
				
	}
}